{% extends "base.html" %}
{% block title %} Film detail {{slug}} {% endblock %}
{% block content %}
<div id="movie-detail" class="list-view">
  <div class="list-item" v-if="movie">
    <div class="list-image">
      <img :src="[[movie.photo]]" />
    </div>
    <div class="list-title">
      <h1>[[movie.name]]</h1>
      <p><span class="star" v-for="rating in movie.rating"></span></p>
    </div>
    <div class="list-body">
      <div class="list-item-meta">
        <span><b>Ticket Price:</b> [[movie.ticket_price]] [[movie.price_currency]]</span>
        <span><b>Releas Date:</b> [[movie.release_date]]</span>
        <span><b>Location:</b> [[movie.country]]</span>
      </div>
      <p class="description">[[movie.description]]</p>
      <div class="movie-genres">
        <b>Genres:</b> <span class="genre" v-for="genre in movie.genres_list" :key="genre.id">[[genre]]</span>
      </div>
    </div>
    {% include '__partials/comments.html' %}
  </div>
</div>
{% endblock %}

{% block script %}
<script type="text/javascript">
  new Vue({
    delimiters: ['[[', ']]'], // default template tag has conflict with django template
    el: "#movie-detail",
    data: {
      movie: null,
      comments: null,
      activeItem: 'signin',
      authenticated: false,
      commentText: null
    },
    computed: {
      getToken() {
        return getAuthToken()
      },
      isAuthenticated() {
        return this.authenticated
      }
    },
    methods: {
      logout() {
        this.authenticated = false
        removeToken()
      },
      onSuccess() {
        this.authenticated = true
      },
      changeActive(item) {
        this.activeItem = item
      },
      async postComment() {
        const data = {
          movie: this.movie.id,
          comment: this.commentText
        }
        try {
          await postComment(data)
          this.commentText = ''
          this.comments = await GetMovieComments(this.movie.id)
        } catch (err) {
          this.errors = err
        }
      },
      checkError(name) {
        if (this.errors) {
          if (this.errors[name]) {
            return this.errors[name]
          }
        }
      }
    },
    watch: {
      movie: {
        deep: true,
        async handler(newVal) {
          if (newVal) {
            this.comments = await GetMovieComments(newVal.id)
          }
        }
      }
    },
    filters: {
      toHumanReadable(val) {
        const d = new Date(val)
        if (d) return d.toDateString()
        return val
      }
    },
    mounted: function () {
      const self = this
      getMovie("{{slug}}").then(function (response) {
        self.movie = response
      })
      
      if (self.getToken) {
        this.authenticated = true
      }
    }
  })
</script>
{% endblock %}